---
title: RTCDataChannel
slug: Web/API/RTCDataChannel
tags:
  - API
  - Communication
  - Data Transfer
  - Experimental
  - Interface
  - Media
  - Networking
  - RTCDataChannel
  - Reference
  - WebRTC
  - WebRTC API
---
<p>{{APIRef("WebRTC")}}</p>

<p>The <strong><code>RTCDataChannel</code></strong> interface represents a network channel which can be used for bidirectional peer-to-peer transfers of arbitrary data. Every data channel is associated with an {{DOMxRef("RTCPeerConnection")}}, and each peer connection can have up to a theoretical maximum of 65,534 data channels (the actual limit may vary from browser to browser).</p>

<p>To create a data channel and ask a remote peer to join you, call the {{DOMxRef("RTCPeerConnection")}}'s {{DOMxRef("RTCPeerConnection.createDataChannel", "createDataChannel()")}} method. The peer being invited to exchange data receives a {{event("datachannel")}} event (which has type {{DOMxRef("RTCDataChannelEvent")}}) to let it know the data channel has been added to the connection.</p>

<div>{{InterfaceOverview("WebRTC")}}</div>

<h2 id="Events">Events</h2>

<dl>
 <dt>{{domxref("RTCDataChannel.bufferedamountlow_event", "bufferedamountlow")}}</dt>
 <dd>Sent to the channel's {{domxref("RTCDataChannel.onbufferedamountlow", "onbufferedamountlow")}} event handler when the number of bytes of data in the outgoing data buffer falls below the value specified by {{domxref("RTCDataChannel.bufferedAmountLowThreshold", "bufferedAmountLowThreshold")}}.</dd>
 <dt>{{domxref("RTCDataChannel.close_event", "close")}}</dt>
 <dd>Sent to the {{domxref("RTCDataChannel.onclose", "onclose")}} event handler when the underlying data transport closes.</dd>
 <dt>{{domxref("RTCDataChannel.error_event", "error")}}</dt>
 <dd>Sent to the {{domxref("RTCDataChannel.onerror", "onerror")}} event handler when an error occurs on the data channel.</dd>
 <dt>{{domxref("RTCDataChannel.message_event", "message")}}</dt>
 <dd>Sent to the {{domxref("RTCDataChannel.onmessage", "onmessage")}} event handler when a message has been received from the remote peer. The message contents can be found in the event's {{domxref("MessageEvent.data", "data")}} property.</dd>
 <dt>{{domxref("RTCDataChannel.open_event", "open")}}</dt>
 <dd>Sent to the {{domxref("RTCDataChannel.onopen", "onopen")}} event handler when the data channel is first opened, or when an existing data channel's underlying connection re-opens.</dd>
</dl>

<h2 id="Data_format">Data format</h2>

<p>The underlying data format is defined by the IEEE draft specification <code><a href="https://datatracker.ietf.org/doc/draft-ietf-mmusic-sctp-sdp">draft-ietf-mmusic-sctp-sdp</a></code>. The current format specifies its protocol as either <code>"UDP/DTLS/SCTP"</code> (UDP carrying DTLS carrying SCTP) or <code>"TCP/DTLS/SCTP"</code> (TCP carrying DTLS carrying SCTP). Older browsers may only specify <code>"DTLS/SCTP"</code>.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">var pc = new RTCPeerConnection();
var dc = pc.createDataChannel("my channel");

dc.onmessage = function (event) {
  console.log("received: " + event.data);
};

dc.onopen = function () {
  console.log("datachannel open");
};

dc.onclose = function () {
  console.log("datachannel close");
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#rtcdatachannel', 'RTCDataChannel') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannel")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC_API">WebRTC API</a></li>
</ul>
